diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/quicktags.dev.js ./wordpress-3.4/wp-includes/js/quicktags.dev.js
*** ./wordpress-3.3.2/wp-includes/js/quicktags.dev.js	2011-11-14 19:15:10.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/quicktags.dev.js	2012-06-12 14:27:41.000000000 -0500
***************
*** 1,6 ****
  /*
   * Quicktags
!  * 
   * This is the HTML editor in WordPress. It can be attached to any textarea and will
   * append a toolbar above it. This script is self-contained (does not require external libraries).
   *
--- 1,6 ----
  /*
   * Quicktags
!  *
   * This is the HTML editor in WordPress. It can be attached to any textarea and will
   * append a toolbar above it. This script is self-contained (does not require external libraries).
   *
***************
*** 51,57 ****
  
  /**
   * Inserts content at the caret in the active editor (textarea)
!  * 
   * Added for back compatibility
   * @see QTags.insertContent()
   */
--- 51,57 ----
  
  /**
   * Inserts content at the caret in the active editor (textarea)
!  *
   * Added for back compatibility
   * @see QTags.insertContent()
   */
***************
*** 61,72 ****
  
  /**
   * Adds a button to all instances of the editor
!  * 
   * Added for back compatibility, use QTags.addButton() as it gives more flexibility like type of button, button placement, etc.
   * @see QTags.addButton()
   */
  function edButton(id, display, tagStart, tagEnd, access, open) {
! 	return QTags.addButton( id, display, tagStart, tagEnd, access, '', -1 );	
  }
  
  (function(){
--- 61,72 ----
  
  /**
   * Adds a button to all instances of the editor
!  *
   * Added for back compatibility, use QTags.addButton() as it gives more flexibility like type of button, button placement, etc.
   * @see QTags.addButton()
   */
  function edButton(id, display, tagStart, tagEnd, access, open) {
! 	return QTags.addButton( id, display, tagStart, tagEnd, access, '', -1 );
  }
  
  (function(){
***************
*** 264,269 ****
--- 264,275 ----
  				html += theButtons['fullscreen'].html(name + '_');
  			}
  
+ 
+ 			if ( 'rtl' == document.getElementsByTagName('html')[0].dir ) {
+ 				theButtons['textdirection'] = new qt.TextDirectionButton();
+ 				html += theButtons['textdirection'].html(name + '_');
+ 			}
+ 
  			ed.toolbar.innerHTML = html;
  			ed.theButtons = theButtons;
  		}
***************
*** 272,278 ****
  
  	/**
  	 * Main API function for adding a button to Quicktags
! 	 * 
  	 * Adds qt.Button or qt.TagButton depending on the args. The first three args are always required.
  	 * To be able to add button(s) to Quicktags, your script should be enqueued as dependent
  	 * on "quicktags" and outputted in the footer. If you are echoing JS directly from PHP,
--- 278,284 ----
  
  	/**
  	 * Main API function for adding a button to Quicktags
! 	 *
  	 * Adds qt.Button or qt.TagButton depending on the args. The first three args are always required.
  	 * To be able to add button(s) to Quicktags, your script should be enqueued as dependent
  	 * on "quicktags" and outputted in the footer. If you are echoing JS directly from PHP,
***************
*** 291,304 ****
  	 * @param arg1 string || function required Either a starting tag to be inserted like "<span>" or a callback that is executed when the button is clicked.
  	 * @param arg2 string optional Ending tag like "</span>"
  	 * @param access_key string optional Access key for the button.
! 	 * @param title string optional Button's title="..." 
  	 * @param priority int optional Number representing the desired position of the button in the toolbar. 1 - 9 = first, 11 - 19 = second, 21 - 29 = third, etc.
  	 * @param instance string optional Limit the button to a specifric instance of Quicktags, add to all instances if not present.
  	 * @return mixed null or the button object that is needed for back-compat.
! 	 */	 	 	 	
  	qt.addButton = function( id, display, arg1, arg2, access_key, title, priority, instance ) {
  		var btn;
! 		
  		if ( !id || !display )
  			return;
  
--- 297,310 ----
  	 * @param arg1 string || function required Either a starting tag to be inserted like "<span>" or a callback that is executed when the button is clicked.
  	 * @param arg2 string optional Ending tag like "</span>"
  	 * @param access_key string optional Access key for the button.
! 	 * @param title string optional Button's title="..."
  	 * @param priority int optional Number representing the desired position of the button in the toolbar. 1 - 9 = first, 11 - 19 = second, 21 - 29 = third, etc.
  	 * @param instance string optional Limit the button to a specifric instance of Quicktags, add to all instances if not present.
  	 * @return mixed null or the button object that is needed for back-compat.
! 	 */
  	qt.addButton = function( id, display, arg1, arg2, access_key, title, priority, instance ) {
  		var btn;
! 
  		if ( !id || !display )
  			return;
  
***************
*** 599,610 ****
  	};
  	qt.FullscreenButton.prototype = new qt.Button();
  	qt.FullscreenButton.prototype.callback = function(e, c) {
! 		if ( c.id != 'content' || typeof(fullscreen) == 'undefined' )
  			return;
  
  		fullscreen.on();
  	};
  
  	// ensure backward compatibility
  	edButtons[10] = new qt.TagButton('strong','b','<strong>','</strong>','b');
  	edButtons[20] = new qt.TagButton('em','i','<em>','</em>','i'),
--- 605,631 ----
  	};
  	qt.FullscreenButton.prototype = new qt.Button();
  	qt.FullscreenButton.prototype.callback = function(e, c) {
! 		if ( !c.id || typeof(fullscreen) == 'undefined' )
  			return;
  
  		fullscreen.on();
  	};
  
+ 	qt.TextDirectionButton = function() {
+ 		qt.Button.call(this, 'textdirection', quicktagsL10n.textdirection, '', quicktagsL10n.toggleTextdirection)
+ 	};
+ 	qt.TextDirectionButton.prototype = new qt.Button();
+ 	qt.TextDirectionButton.prototype.callback = function(e, c) {
+ 		var isRTL = ( 'rtl' == document.getElementsByTagName('html')[0].dir ),
+ 			currentDirection = c.style.direction;
+ 
+ 		if ( ! currentDirection )
+ 			currentDirection = ( isRTL ) ? 'rtl' : 'ltr';
+ 
+ 		c.style.direction = ( 'rtl' == currentDirection ) ? 'ltr' : 'rtl';
+ 		c.focus();
+ 	}
+ 
  	// ensure backward compatibility
  	edButtons[10] = new qt.TagButton('strong','b','<strong>','</strong>','b');
  	edButtons[20] = new qt.TagButton('em','i','<em>','</em>','i'),
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/swfupload/handlers.dev.js ./wordpress-3.4/wp-includes/js/swfupload/handlers.dev.js
*** ./wordpress-3.3.2/wp-includes/js/swfupload/handlers.dev.js	2011-07-29 14:21:21.000000000 -0500
--- ./wordpress-3.4/wp-includes/js/swfupload/handlers.dev.js	2012-03-15 08:30:28.000000000 -0500
***************
*** 96,102 ****
  	jQuery('a.delete', item).click(function(){
  		// Tell the server to delete it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: 'admin-ajax.php',
  			type: 'post',
  			success: deleteSuccess,
  			error: deleteError,
--- 96,102 ----
  	jQuery('a.delete', item).click(function(){
  		// Tell the server to delete it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: ajaxurl,
  			type: 'post',
  			success: deleteSuccess,
  			error: deleteError,
***************
*** 114,120 ****
  	jQuery('a.undo', item).click(function(){
  		// Tell the server to untrash it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: 'admin-ajax.php',
  			type: 'post',
  			id: fileObj.id,
  			data: {
--- 114,120 ----
  	jQuery('a.undo', item).click(function(){
  		// Tell the server to untrash it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: ajaxurl,
  			type: 'post',
  			id: fileObj.id,
  			data: {
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/tinymce/langs/wp-langs-en.js ./wordpress-3.4/wp-includes/js/tinymce/langs/wp-langs-en.js
*** ./wordpress-3.3.2/wp-includes/js/tinymce/langs/wp-langs-en.js	2011-11-12 00:15:15.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/tinymce/langs/wp-langs-en.js	2012-03-05 01:31:31.000000000 -0600
***************
*** 12,18 ****
  clipboard_msg:"Copy/Cut/Paste is not available in Mozilla and Firefox.",
  clipboard_no_support:"Currently not supported by your browser, use keyboard shortcuts instead.",
  popup_blocked:"Sorry, but we have noticed that your popup-blocker has disabled a window that provides application functionality. You will need to disable popup blocking on this site in order to fully utilize this tool.",
! invalid_data:"Error: Invalid values entered, these are marked in red.",
  invalid_data_number:"{#field} must be a number",
  invalid_data_min:"{#field} must be a number greater than {#min}",
  invalid_data_size:"{#field} must be a number or percentage",
--- 12,18 ----
  clipboard_msg:"Copy/Cut/Paste is not available in Mozilla and Firefox.",
  clipboard_no_support:"Currently not supported by your browser, use keyboard shortcuts instead.",
  popup_blocked:"Sorry, but we have noticed that your popup-blocker has disabled a window that provides application functionality. You will need to disable popup blocking on this site in order to fully utilize this tool.",
! invalid_data:"ERROR: Invalid values entered, these are marked in red.",
  invalid_data_number:"{#field} must be a number",
  invalid_data_min:"{#field} must be a number greater than {#min}",
  invalid_data_size:"{#field} must be a number or percentage",
***************
*** 240,247 ****
  samp:"Code sample",
  dt:"Definition term ",
  dd:"Definition description",
! bold_desc:"Bold (Ctrl / Alt + Shift + B)",
! italic_desc:"Italic (Ctrl / Alt + Shift + I)",
  underline_desc:"Underline",
  striketrough_desc:"Strikethrough (Alt + Shift + D)",
  justifyleft_desc:"Align Left (Alt + Shift + L)",
--- 240,247 ----
  samp:"Code sample",
  dt:"Definition term ",
  dd:"Definition description",
! bold_desc:"Bold (Ctrl + B)",
! italic_desc:"Italic (Ctrl + I)",
  underline_desc:"Underline",
  striketrough_desc:"Strikethrough (Alt + Shift + D)",
  justifyleft_desc:"Align Left (Alt + Shift + L)",
***************
*** 310,315 ****
--- 310,316 ----
  colorpicker_color:"Color:",
  colorpicker_name:"Name:",
  charmap_title:"Select custom character",
+ charmap_usage:"Use left and right arrows to navigate.",
  image_title:"Insert/edit image",
  image_src:"Image URL",
  image_alt:"Image description",
